Attribute VB_Name = "uci_IDllMap"
'
'  CommIntfDll - Mapovn funkc z knihovny CommIntfDll.dll
'  Vytvoeno pro Delphi 7
'
'  Vydavatel :  Papouch s.r.o. - http://www.papouch.com/
'  Autor     :  Martin Zmenk zamecnik@papouch.com
'
'  popis     : knihovna umouje komunikaci nejen se zazenmi firmy papouch s.r.o. pes sriov port, usb a ethernet (TCP nebo UDP)
'              komunikan spojen se vytv pomoc funkc ciCreate a pedanho ppojovacho etzce (ten uruje, o jak rozhrann se jend, a dal parametry),
'              tyto funkce vracej Handle (madlo) komunikanho rozhrann, kter se pak pedv ostatnm funkcm
'              vechny funkce jsou spolen pro vechny typy rozhrann. funkce s nvratovou hodnotou reStat (integer) vracej ERR_OK (0) pokud ve problo v podku, jinak chybov kd
'
'  Poznmky  : k pouit funkc je poteba knihovna CommIntfDll.dll,
'              v ppad pouit pro USB jsou poteba t nainstalovan ovladae FTD direct drivers a knihova FTD2XX.dll, nebo nainstalovan virtuln sriov port
              
Option Explicit

Public Const ciev_Base = 255  '-- Konstanty pro Typ udlosti komunikanho rozhran
Public Const ciev_Open = ciev_Base + 1
Public Const ciev_Close = ciev_Base + 2
Public Const ciev_DataRcv = ciev_Base + 3
Public Const ciev_Error = ciev_Base + 4

'***funkce pro sprvu chyb***
Public Declare Function LastError Lib "CommIntfDll.dll" () As Long '-- Zjist slo posledn chyby
Public Declare Function LastErrorText Lib "CommIntfDll.dll" (ByVal Text As String, ByRef Size As Long) As Long
                       '-- Zsk text posledn chyby. Text=buffer, do kterho bude text pedn, Size=velikost bufferu Text, zpt vrt poet znak textu.
                       '-- Pokud je Size men ne potebn velikost pro text, je nvratov hodnota ERR_MoreSize a do Size se nastav potebn velikost
                       '-- Pokud je Text NIL, pouze se do Size vrt potebn velikost bufferu pro text
                       '-- Pokud ve probhlo v podku, vrt se ERR_OK (0)
                       '-- pozn. tento princip funguje u vtiny funkc, kde se zskv textov hodnota
Public Declare Function SetLastError Lib "CommIntfDll.dll" (ByVal ErrNum As Long, ByVal Text As String) As Long
                      '-- Nastav Chybu. Pedv se slo chyby a text chyby
'*** info ***
Public Declare Function Info Lib "CommIntfDll.dll" () As String '-- Vrt informan text o knihovn

'*** funkce pro prci s komunikanm rozhrannm ****
Public Declare Function ciCreate Lib "CommIntfDll.dll" (ByVal ConnectionString As String) As Long '-- Vytvo komunikan rozhrann podle zadanho pipojovacho etzce
    '--       connection string je etzec pro vytvoen komunikanho rozhrann, uruje komunikan kanl a jeho nastaven (sriov port, tcp, udp, nebo ftd_usb)
    '   Tvorba connectionstringu  as  jsou to hodnoty ve tbyrefu "parametr=hodnota" oddLeny stednkem. uruj typ pipojen
    '          nejdleitjm parametrem je "provider", uruje typ rozhrann. me to bt SERIAL_PORT, TCP_CLIENT, UDP_CLIENT nebo FTD_USB
    '          kad kanl pak me mt dal parametry. SERIAL_PORT (comport=slo portu,baudrate=rychlost - nemus bt zadno), TCP_CLIENT(host=ip adresa zazen,port=tcp port zazen), UDP_CLIENT(stejn jako TCP),
    '                                                    FTD_USB(index=poadov slo zazen, nebo device=st nzvu zazen, nebo serial_number=sriov slo zazen, nebo vid=vid,pid=pid, nebo nemus mt dn parametr, vezme se prvn pipojen zazen typu FTD_USB
    '          pklady as  "provider=SERIAL_PORT,comport=1", "provider=TCP_CLIENT,host=192.168.1.254,port=10001", "provider=UDP_CLIENT,host=192.168.1.254,port=10001", "provider=FTD_USB,device=Quido"
    '          Nvratov hodnota je Handle na vytvoen komunikan rozhrann. 0 = Nebylo vytvoeno

Public Declare Function ciCreateM Lib "CommIntfDll.dll" (ByVal ConnectionString As String, ByVal NotificationHWND As Long, ByVal Msg As Long, ByVal Blocking As Boolean) As Long
                      '-- vytvo komunikan rozhrann viz. ciCreate, navc zaregistruje pjem udlost pomoc windows zprv.
                      '   Notificationlong = handle okna kam maj zprvy chodit, Msg = Jak zprva se bude zaslat,
                      '   Blocking=jakou medodou budou zprvy zaslny as  true-SendMessage-rozhrann ek na zpracovn udlost, false-PostMessage-rozhrann asynchronn zale upozornn o udlosti a neek na jeho zpracovn
                      '   viz. ciRegisterMsgNotifications
Public Declare Function ciCreateCB Lib "CommIntfDll.dll" (ByVal ConnectionString As String, ByVal CallBackEntryPoint As Long, ByVal CallBackID As Long) As Long
                      '-- vytvo komunikan rozhrann viz. ciCreate, navc zaregistruje pjem udlost pomoc CallBackov funkce
                      '   CallBackEntryPoint = vstupn bod Callbackov funkce typu longNotificationEvent
                      '   CallBackID = voliteln parametr, kter bude zpt zasln pi zptnm voln (voliteln identifikace)
                      '   viz. ciRegisterCallBackNotifications
Public Declare Function ciOpen Lib "CommIntfDll.dll" (ByVal Handle As Long) As Long '-- oteve komunikan kanl (oteve port, nave tcp spojen, ... podle typu komunikanho rozhran, nutno ped zapoetm komunikace, vrt 0 pokud OK, chybov kd v opanm ppad
                                                  '   Jako handle se pedv handle zskan z funkc ciCreate
Public Declare Function ciClose Lib "CommIntfDll.dll" (ByVal Handle As Long) As Long '-- zave komunikan kanl
Public Declare Function ciRelease Lib "CommIntfDll.dll" (ByVal Handle As Long) As Long '-- Zru komunikan kanl a pslun handle
Public Declare Function ciIsActive Lib "CommIntfDll.dll" (ByVal Handle As Long, ByRef Active As Long) As Long '-- Zjist, zda je komunikan rozhrann oteveno. pokud je nvratov hodnota 0, do parametru Active je vrcen stav
Public Declare Function ciRead Lib "CommIntfDll.dll" (ByVal Handle As Long, ByVal Buffer As String, ByRef Size As Long) As Long  '-- Nate pchoz data. Size se nastav na velikost bufferu, vrti se poet natench byt
Public Declare Function ciWrite Lib "CommIntfDll.dll" (ByVal Handle As Long, ByVal Buffer As String, ByVal Size As Long) As Long  '-- Pole data po komunikanm rozhrann
Public Declare Function ciReadLength Lib "CommIntfDll.dll" (ByVal Handle As Long) As Long '-- Zjist, kolik byt je ve vstupnm bufferu pipraveno k naten
Public Declare Function ciClearReadBuffer Lib "CommIntfDll.dll" (ByVal Handle As Long) As Long '-- Vymae pchoz data ze vstupnho bufferu

'funkce pro usnadnn synchronn komunikace typu dotaz-odpov
Public Declare Function ciSndGet Lib "CommIntfDll.dll" (ByVal Handle As Long, ByRef SndBuffer, ByVal Size As Long, ByRef RcvBytes As Long, ByVal MaxTimeOut As Long) As Long
        '-- Odele data (Size byt ze SndBufferu) a ek na odpov (Maximln MaxTimeOut milisekund). V RcvBytes vrt, kolik byt bylo pijato jako odpov. Odpov lze pijmout pomoc ciRead
Public Declare Function ciSndGetSpinel97 Lib "CommIntfDll.dll" (ByVal Handle As Long, ByRef SndBuffer, ByVal Size As Long, ByRef RcvBytes As Long, ByVal MaxTimeOut As Long) As Long
        '-- Stejn jako ciSndGet odele data a ek na odpov. Jako odpov vak oekv Spinel paket. v RcvBytes vrt poet pijatch byt platnho Spinel paketu. Pokud nebyl platn paket pijat, nvratov hodnota signalizuje chybu a RcvBytes je 0.
        '-- Odpov lze zskat funkc ciRead nebo ciReadSpin97.
Public Declare Function ciSndGetSpin97 Lib "CommIntfDll.dll" (ByVal Handle As Long, ByVal Adr As Byte, ByVal Sig As Byte, ByVal Inst As Byte, ByVal Data As String, ByVal DataLength As Long, ByRef RcvBytes As Long, ByVal MaxTimeOut As Long) As Long
        '-- Odele Spinelovsk paket, vytvoen parametry Adr, Sig, Inst a Data (Dlky DataLen). Zbytek spinelovsk hlaviky (prefix, dlka, CRC, ..) se vypot automaticky.
        '   Odpov jako u ciSndGetSpinel97
Public Declare Function ciReadSpin97 Lib "CommIntfDll.dll" (ByVal Handle As Long, ByRef Adr As Byte, ByRef Sig As Byte, ByRef Ack As Byte, ByVal Data As String, ByRef DataSize As Long) As Long
        '-- Nate Spinel paket z pijatch dat. pokud v pijatch datech nen platn spinel paket, nvratov hodnota signalizuje chybu.
        '   Pokud byl pijat paket, napln se z nj hodnoty Adr, Sig a Ack a Data. v DataSize je teba zadat velikost bufferu Data, zpt se vrt aktuln velikost Dat.
Public Declare Function ciRegisterMsgNotifications Lib "CommIntfDll.dll" (ByVal Handle As Long, ByVal WHandle As Long, ByVal Msg As Long, ByVal Blocking As Long) As Long
                      '-- Zaregistruje pjem udlost pomoc windows zprv.
                      '   Notificationlong = handle okna kam maj zprvy chodit, Msg = Jak zprva se bude zaslat,
                      '   Blocking=jakou medodou budou zprvy zaslny as  true-SendMessage-rozhrann ek na zpracovn udlost, false-PostMessage-rozhrann asynchronn zale upozornn o udlosti a neek na jeho zpracovn
                      '   Zprva pijde ve tbyrefu  as  Msg = Msg, wParam = Handle, lParamLow = Typ udlosti (ciev_Open, ciev_Close, ciev_DataRcv, ciev_Error), lParamHi = ppadn dodaten parametr
Public Declare Function ciUnregisterMsgNotifications Lib "CommIntfDll.dll" (ByVal Handle As Long) As Long '-- Odregistruje pjem udlost pomoc widnows zprv
Public Declare Function ciRegisterCallBackNotifications Lib "CommIntfDll.dll" (ByVal Handle As Long, ByVal CallBackEntryPoint As Long, ByVal CallBackID As Long) As Long
                      '-- Zaregistruje pjem udlost pomoc CallBackov funkce
                      '   CallBackEntryPoint = vstupn bod Callbackov funkce typu longNotificationEvent
                      '   CallBackID = voliteln parametr, kter bude zpt zasln pi zptnm voln (voliteln identifikace)
                      '   Callbackov funkce je pak volna s tmito parametry  as  Handle-Handle rozhran,Event-typ udlosti (ciev_Open, ciev_Close, ciev_DataRcv, ciev_Error),Param-ppadn parametr, CallBackID-voliteln parametry zadan pi registraci
Public Declare Function ciUnregisterCallBackNotifications Lib "CommIntfDll.dll" (ByVal Handle As Long) As Long '-- Odregistruje pjem udlost pomoc callbackov funkce
Public Declare Function ciEnumHandles Lib "CommIntfDll.dll" (ByRef HandleList, ByRef Size As Long) As Long '-- Vrt seznam vech aktuln vytvoench komunikanch rozhranch
Public Declare Function ciHandlesCount Lib "CommIntfDll.dll" () As Long '-- Vrt poet aktuln vytvoench komunikanch rozhranch
Public Declare Function ciHandleByIndex Lib "CommIntfDll.dll" (ByVal index As Long) As Long '-- Vrt handle podle indexu (0 .. ciHandlesCount-1)
Public Declare Function ciGetDescription Lib "CommIntfDll.dll" (ByVal Handle As Long, ByVal Description As String, ByRef Length As Long) As Long '-- Vrt popis komunikanho rozhran
Public Declare Function ciGetID Lib "CommIntfDll.dll" (ByVal Handle As Long, ByVal ID As String, ByRef Length As Long) As Long '--  Vrt textovou identifikaci rozhran
Public Declare Function ciGetProvider Lib "CommIntfDll.dll" (ByVal Handle As Long, ByVal Provider As String, ByRef Length As Long) As Long '-- Vrti typ rozhrann (SERIAL_PORT, TCP_CLIENT, UDP_CLIENT nebo FTD_USB)
Public Declare Function ciGetValid Lib "CommIntfDll.dll" (ByVal Handle As Long, ByRef Valid As Long) As Long '-- rezervovno
Public Declare Function ciSetValid Lib "CommIntfDll.dll" (ByVal Handle As Long, ByVal Valid As Long) As Long '-- rezervovno
Public Declare Function ciExecuteConfigDialog Lib "CommIntfDll.dll" (ByVal Handle As Long) As Long '-- Spust se konfiguran dialog konkrtnho komunikanho rozhrann
Public Declare Function ciConfigDialogAvailable Lib "CommIntfDll.dll" (ByVal Handle As Long) As Long '-- Zjist, zda rozhran podporuje konfiguran dialog
'-------------
Public Declare Function ciGetConfig Lib "CommIntfDll.dll" (ByVal Handle As Long, ByVal ConfigString As String, ByRef Length As Long) As Long '-- Zsk konfiguran etzec rozhran
Public Declare Function ciSetConfig Lib "CommIntfDll.dll" (ByVal Handle As Long, ByVal ConfigString As String) As Long '-- Nastav konfiguran etzec rozhran
Public Declare Function ciGetConfigValue Lib "CommIntfDll.dll" (ByVal Handle As Long, ByVal ParamName As String, ByVal Value As String, ByRef Length As Long) As Long '-- Zjsk jednu hodnotu z konfiguranho etzce, ParamName=nzev parametru, Value=buffer, do kterho se vrt textov podoba hodnoty
Public Declare Function ciGetConnectionStringDlg Lib "CommIntfDll.dll" (ByVal OutConnStr As String, ByRef Length As Long, ByRef OKReturn As Long, ByVal DefaultValue As String, ByVal Caption As String) As Long
      '-- Zobraz dialog pro vytvoen konfiguranho etzce. OutConnStr = buffer pro uloen vsledku, Length = velikost bufferu OutConnStr, zpt vrt aktuln velikost etzce, OKReturn=vrt, zda bylo stisknuto OK,
      '   DefaultValue = Vchoz konfiguran etzec, Caption = Titulek okna konfiguranho etzce
'--------------

'*** funkce pro vet sriovch port a FTD USB zazen ***
Public Declare Function EnumSerialPorts Lib "CommIntfDll.dll" (ByRef Ports, ByRef Size As Long) As Long '-- Vrt seznam sriovch port na potai (vetn virtulnch)
            ' Ports - buffer (ukazatel na pole long), kam se ulo vsledek, Size - velikost bufferu v bytech, zpt vrt aktuln velikost v bytech, nvratov hodnota - poet port (-1 = chyba)
Public Declare Function SerialPortCount Lib "CommIntfDll.dll" () As Long  '-- Poet sriovch port na potai
Public Declare Function SerialPortNumByIndex Lib "CommIntfDll.dll" (ByVal index As Long) As Long '-- Vrt slo portu podle indexu (0..SerialPortCount-1)
Public Declare Function SerialPortByIndex Lib "CommIntfDll.dll" (ByVal index As Long, ByVal PortName As String, ByRef Length As Long) As Long '-- Vrt nzev portu podle indexu (0..SerialPortCount-1) nap as  "COM3"
Public Declare Function GetSerialPortState Lib "CommIntfDll.dll" (ByVal PortNum As Long) As Long '-- Vrt stav sriovho portu (oteven, zaven, neexistuje)
Public Declare Function FTDDeviceCount Lib "CommIntfDll.dll" () As Long '-- Poet zazen pipojench pes FTD USB
Public Declare Function FTDGetDetailByIndex Lib "CommIntfDll.dll" (ByVal index As Long, ByRef Flags As Long, ByRef Typ As Long, ByRef ID As Long, ByRef LocID As Long, ByVal SerialNum As String, ByVal Description As String) As Long
    '-- Zjist informace o USB zazen podle indexu (0..FTDDeviceCount-1). Flags, Typ, ID a Loc jsou ukazatele na 32bitov sla. parametry kter nechceme vrtit mou bt NIL
    '-- SerialNum a Description jsou buffery pro uloen textu, mli by bt alokovny na dostatenou velikost, nebo NIL, pokud ns nezajmaj. 32B pro SerialNum a 128B pro Description by mlo urit stait.
Public Declare Function FTDSerNumByIndex Lib "CommIntfDll.dll" (ByVal index As Long, ByVal SerNum As String, ByRef Length As Long) As Long
    '-- Zjist sriov slo USB zazen podle indexu
Public Declare Function FTDDevNameByIndex Lib "CommIntfDll.dll" (ByVal index As Long, ByVal DevName As String, ByRef Length As Long) As Long
    '-- Zjist nzev zazen USB zazen podle indexu
Public Declare Function FTDVidPidByIndex Lib "CommIntfDll.dll" (ByVal index As Long, ByRef VID As Long, ByRef PID As Long) As Long
    '-- Zjist VID a PID hodnoty (identifikace vrobce a produktu) USB zazen
Public Declare Function FTDFindDevice Lib "CommIntfDll.dll" (ByVal start As Long, ByVal SerNum As String, ByVal DevName As String, ByRef VID As Long, ByRef PID As Long, ByRef index As Long) As Long
    '-- Vyhled v dostupnch USB zazen na potai (prvn) ten, kter odpovd zadanm parametrm. do Index vrt jeho Index.
    '   parametry se pedvaj ukazatelem na hodnotu nebo etzec. parametry mohou bt vynechny zadnm NIL.
Public Declare Function FTDFindDeviceCS Lib "CommIntfDll.dll" (ByVal start As Long, ByVal Params As String, ByRef index As Long) As Long
    '-- Vyhled USB zazen podle parametr, jako FTDFindDevice, akort se parametry pedvaj v jednom etzci oddLen stednkem as
    '   Lze zadat nkter z tchto parametr as
    '   index=zad pmo index, nebo device=st nzvu zazen, nebo serial_number=sriov slo zazen, nebo vid=vid,pid=pid, nebo nemus mt dn parametr, vezme se prvn pipojen zazen typu FTD_USB)
    '   do Index se vrt Index zazen, kter odpovd vem zadanm parametrm. V ppad e tomu dn zazen neodpovd, vrt se do Index -1.


'********* POMOCN FUNKCE *************

Public Function SndRcvSpin97(ByVal Handle As Long, ByRef Adr As Byte, Sig As Byte, ByVal Inst As Byte, ByVal Data As String, ByRef Ack As Byte, ByRef ReturnData As String, Optional ByVal MaxTimeOut As Long = 500) As Boolean
  Dim RetLen As Long
  Dim Dat As String
  SndRcvSpin97 = False
  If ciSndGetSpin97(Handle, Adr, Sig, Inst, Data, Len(Data), RetLen, MaxTimeOut) = 0 Then
    Dat = String(RetLen, " ")
    If RetLen > 0 Then
        If ciReadSpin97(Handle, Adr, Sig, Ack, Dat, RetLen) = 0 Then
          ReturnData = Left(Dat, RetLen)
          SndRcvSpin97 = True
        End If
    End If
  End If
End Function


